<?php

namespace HCM\BTL\Services;

use Doctrine\ORM\EntityManager;
use Geral\Util\DateTime;
use HCM\Util\DateUtil;
use HCM\Util\HCMParameters;
use HCM\BTL\Repository\ProcessoSeletivoRepository;

class ProcessoSeletivoService {

    protected $entityManager;
    protected $hcmParameters;
    protected $processoSeletivoRepository;

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, ProcessoSeletivoRepository $processoSeletivoRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->processoSeletivoRepository = $processoSeletivoRepository;
    }
    
    public function getOperadorParcnegocio($nrorg, $nrparcnegocio) {
        return $this->processoSeletivoRepository->getOperadorParcnegocio($nrorg, $nrparcnegocio);
    }

    public function setMediaTotal($parameters) {
        $query = $this->entityManager->getConnection()->prepare("
            UPDATE DES_PARTICIPAPROCESSO
               SET VRMEDIAPROCESSO =
                   (SELECT ROUND(AVG(NRPERCENTUAL),2) MEDIA
                      FROM DES_PARTICIPAFASE
                     WHERE NRORG             = DES_PARTICIPAPROCESSO.NRORG
                       AND NRPROCESSO        = DES_PARTICIPAPROCESSO.NRPROCESSO
                       AND NRPARCNEGOCIOCAND = DES_PARTICIPAPROCESSO.NRPARCNEGOCIOCAND
                  GROUP BY NRPARCNEGOCIOCAND
                  )
            WHERE NRORG    = :P_NRORG
            AND NRPROCESSO = :P_NRPROCESSO
        ");

        $return = $query->execute(
            array(
                "P_NRORG"      => $parameters["NRORG"],
                "P_NRPROCESSO" => $parameters["NRPROCESSO"]
            )
        );        

        if ($return)
            return true;
        else
            return false;
    }

    public function setReprovados($parameters) {
        $this->processoSeletivoRepository->setReprovados($parameters);
    }

    public function setDtConclusaoProcesso($parameters) {
        return $this->processoSeletivoRepository->setDtConclusaoProcesso($parameters);
    }

    public function setNrAvaliacao($parameters) {
        return $this->processoSeletivoRepository->setNrAvaliacao($parameters);
    }
}

