<?php

namespace HCM\Geral\Entity;

use HCM\Util\Repositories;
use HCM\Util\MsgCalculo;
use HCM\Util\Util;
use HCM\Util\FPA;
use HCM\Util\TkEntity;

class GpesitufuncmEntity extends TkEntity
{
    const SITUACAO_FUNCIONAL_NORMAL = 1;
    const SITUACAO_FUNCIONAL_MATERNIDADE = 5;
    const SITUACAO_FUNCIONAL_ATESTADO = 12;
    const SITUACAO_FUNCIONAL_DOENCA_MENOR_15 = 15;
    const SITUACAO_FUNCIONAL_DOENCA_MAIOR_15 = 6;
    const SITUACAO_FUNCIONAL_ACIDENTE_MENOR_15 = 16;
    const SITUACAO_FUNCIONAL_ACIDENTE_MAIOR_15 = 3;
    const SITUACAO_FUNCIONAL_DEMITIDO = 13;
    const SITUACAO_FUNCIONAL_LICENCA_REMUNERADA = 17;

    private $_situFuncResumo = array();
    public $historico;
    
    public function __construct($entityManager, $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->dtCompetencia = $hcmParameters->getDtCompetencia();
        parent::__construct(null,$entityManager);
    }
    
    public function getSituacaoFuncionalResumo(){
        return $this->_situFuncResumo;
    }

    private function _inicializaLista($nrOrgPadrao, $nrOrgTrabalho){
        
        $tmp = $this->entityManager->getRepository(Repositories::GPE_SITUFUNCM)->retornaSituacaoFuncional($nrOrgPadrao, $nrOrgTrabalho, $this->dtCompetencia);
        
        foreach ($tmp as $tmp_situacao) {
            $this->addItem($tmp_situacao, $tmp_situacao->getNrsitufuncm());
            $this->_situFuncResumo[$tmp_situacao->getNrsitufuncm()] = 0;
        }
    }

    public function retornaSituacaoFuncional($nrOrgPadrao, $nrOrgTrabalho, $nr_situacao){
        if ($nr_situacao > 0) {
            $itens = $this->getItems();
            
            if (count($itens) === 0) {
                $this->_inicializaLista($nrOrgPadrao, $nrOrgTrabalho);
                $itens = $this->getItems();
            }

            return $itens[$nr_situacao];
        }

    }

    public function criaSituacaoFuncional($dtVigencia){

        $situacaoFuncional = new self();
        $situacaoFuncional->setDtinivigencia($dtVigencia);
        $situacaoFuncional->persist();

        $nrSituacao = $situacaoFuncional->getNrsitufuncm();

        unset($situacaoFuncional);
        return $nrSituacao;
    }

    public function novoMestre($nrsitufuncm, $nrorgTrab){
        try{
            $now = new TkDateTime();
            $now = $now->toString(TkDateTime::FORMAT_DATE);

            $this->setNrsitufuncm($nrsitufuncm);
            $this->setDtinivigencia($now);
            $this->setNrorg($nrorgTrab);
            $this->setDtinclusao($now);

            $this->persist();

            return true;
        }
        catch (Exception $e){
            return false;
        }

    }

    public function destroiMestre($nrsitufuncm, $nrorgTrab){
        try{
            $situfuncm = Gpesitufuncm::retornaSituFuncPelaChave($nrsitufuncm, $nrorgTrab);
            if (is_object($situfuncm) === true) {
                $this->addItem($situfuncm, $nrsitufuncm);
                $this->removeItem($situfuncm);
                $this->persist();

                return true;
            } else {
                return false;
            }
        }
        catch (Exception $e){
            return false;
        }

    }

    public function getHistorico() {
        if (!$this->historico) {
            $this->historico = \Gpesitufunch::getObjectByWhere(
                'NRSITUFUNCM = ?',
                array($this->getNrsitufuncm())
            );
        }
        return $this->historico;
    }
    
}

