<?php
namespace HCM\PTO\Services;

use Doctrine\ORM\EntityManager;
use HCM\PTO\Repository\EscalaTrabalhoRepository;
use HCM\Util\Repositories;

class EscalaTrabalhoService {

    public function __construct(EntityManager $entityManager, EscalaTrabalhoRepository $escalaTrabalhoRepository) {
        $this->entityManager = $entityManager;
        $this->escalaTrabalhoRepository = $escalaTrabalhoRepository;
    }

    public function verificaExistenciaTurno($nrEscalaTrabM, $nrOrg) {
        return $this->escalaTrabalhoRepository->verificaExistenciaTurno($nrEscalaTrabM, $nrOrg);
    }
    
    public function validaCamposVazios(&$row){
        
        
        $row['IDDESCINTERVALOFERIADO'] = (!isset($row['IDDESCINTERVALOFERIADO']) || empty($row['IDDESCINTERVALOFERIADO'])) ?  'S'  : $row['IDDESCINTERVALOFERIADO'];
        $row['IDADCNOTURNOINTERVALO']  = (!isset($row['IDADCNOTURNOINTERVALO'])  || empty($row['IDADCNOTURNOINTERVALO']))  ?  'N'  : $row['IDADCNOTURNOINTERVALO'];
        $row['IDDESCINTERVALOSABADO']  = (!isset($row['IDDESCINTERVALOSABADO'])  || empty($row['IDDESCINTERVALOSABADO']))  ?  'S'  : $row['IDDESCINTERVALOSABADO'];
        $row['IDTURNOINTERVALOEXTRA']  = (!isset($row['IDTURNOINTERVALOEXTRA'])  || empty($row['IDTURNOINTERVALOEXTRA']))  ?  'N'  : $row['IDTURNOINTERVALOEXTRA'];
        $row['QTHRPROJETAINTERVALO']   = (!isset($row['QTHRPROJETAINTERVALO'])   || empty($row['QTHRPROJETAINTERVALO']))   ? '0100': $row['QTHRPROJETAINTERVALO'];
        $row['IDNAOCONTROLAJORNADA']   = (!isset($row['IDNAOCONTROLAJORNADA'])   || empty($row['IDNAOCONTROLAJORNADA']))   ?  null : $row['IDNAOCONTROLAJORNADA'];
        $row['IDDESCINTERVALOFOLGA']   = (!isset($row['IDDESCINTERVALOFOLGA'])   || empty($row['IDDESCINTERVALOFOLGA']))   ?  'S'  : $row['IDDESCINTERVALOFOLGA'];
        $row['QTHRLIMITESEPHEXTRA']    = (!isset($row['QTHRLIMITESEPHEXTRA'])    || empty($row['QTHRLIMITESEPHEXTRA']))    ? '0200': $row['QTHRLIMITESEPHEXTRA'];
        $row['HRINIPERIODONOTURNO']    = (!isset($row['HRINIPERIODONOTURNO'])    || empty($row['HRINIPERIODONOTURNO']))    ? '2200': $row['HRINIPERIODONOTURNO'];
        $row['HRFIMPERIODONOTURNO']    = (!isset($row['HRFIMPERIODONOTURNO'])    || empty($row['HRFIMPERIODONOTURNO']))    ? '0500': $row['HRFIMPERIODONOTURNO'];
        $row['IDEXIGEAUTHORAEXTRA']    = (!isset($row['IDEXIGEAUTHORAEXTRA'])    || empty($row['IDEXIGEAUTHORAEXTRA']))    ?  'N'  : $row['IDEXIGEAUTHORAEXTRA'];
        $row['IDTURNOEXTRAFERIADO']    = (!isset($row['IDTURNOEXTRAFERIADO'])    || empty($row['IDTURNOEXTRAFERIADO']))    ?  'N'  : $row['IDTURNOEXTRAFERIADO'];
        $row['IDGERAMARCVIRADADIA']    = (!isset($row['IDGERAMARCVIRADADIA'])    || empty($row['IDGERAMARCVIRADADIA']))    ?  'N'  : $row['IDGERAMARCVIRADADIA'];
        $row['IDHEXTRANMARCINTERV']    = (!isset($row['IDHEXTRANMARCINTERV'])    || empty($row['IDHEXTRANMARCINTERV']))    ?  'S'  : $row['IDHEXTRANMARCINTERV'];
        $row['IDMANTEMPERCVIRADA']     = (!isset($row['IDMANTEMPERCVIRADA'])     || empty($row['IDMANTEMPERCVIRADA']))     ?  'S'  : $row['IDMANTEMPERCVIRADA'];
        $row['IDPROJETAINTERVALO']     = (!isset($row['IDPROJETAINTERVALO'])     || empty($row['IDPROJETAINTERVALO']))     ?  'S'  : $row['IDPROJETAINTERVALO'];
        $row['NRSITFREQMAXHRTRAB']     = (!isset($row['NRSITFREQMAXHRTRAB'])     || empty($row['NRSITFREQMAXHRTRAB']))     ?  null : $row['NRSITFREQMAXHRTRAB'];          
        $row['IDATRASOSOPRIMARC']      = (!isset($row['IDATRASOSOPRIMARC'])      || empty($row['IDATRASOSOPRIMARC']))      ?  'N'  : $row['IDATRASOSOPRIMARC'];
        $row['IDCOMPENSAATRASO']       = (!isset($row['IDCOMPENSAATRASO'])       || empty($row['IDCOMPENSAATRASO']))       ?  'S'  : $row['IDCOMPENSAATRASO'];
        $row['IDFALTASREFLEXO']        = (!isset($row['IDFALTASREFLEXO'])        || empty($row['IDFALTASREFLEXO']))        ?  null : $row['IDFALTASREFLEXO'];
        $row['DTFIMVIGENCIA']          = (!isset($row['DTFIMVIGENCIA'])          || empty($row['DTFIMVIGENCIA']))          ?  null : $row['DTFIMVIGENCIA'];
        $row['NRTPINTERVALO']          = (!isset($row['NRTPINTERVALO'])          || empty($row['NRTPINTERVALO']))          ?  null : $row['NRTPINTERVALO'];
        $row['IDUTAPURATEST']          = (!isset($row['IDUTAPURATEST'])          || empty($row['IDUTAPURATEST']))          ?  'N'  : $row['IDUTAPURATEST'];
        $row['QTHRMAXHRTRAB']          = (!isset($row['QTHRMAXHRTRAB'])          || empty($row['QTHRMAXHRTRAB']))          ?  null : $row['QTHRMAXHRTRAB'];
        $row['NRDIAINIAPUR']           = (!isset($row['NRDIAINIAPUR'])           || empty($row['NRDIAINIAPUR']))           ?  null : $row['NRDIAINIAPUR'];
        $row['NRDIAFINAPUR']           = (!isset($row['NRDIAFINAPUR'])           || empty($row['NRDIAFINAPUR']))           ?  null : $row['NRDIAFINAPUR'];
        $row['IDUTAPURADSR']           = (!isset($row['IDUTAPURADSR'])           || empty($row['IDUTAPURADSR']))           ?  'N'  : $row['IDUTAPURADSR'];
        $row['IDGERBENFER']            = (!isset($row['IDGERBENFER'])            || empty($row['IDGERBENFER']))            ?  'N'  : $row['IDGERBENFER'];
        $row['NRTPJORNADA']            = (!isset($row['NRTPJORNADA'])            || empty($row['NRTPJORNADA']))            ?  null : $row['NRTPJORNADA'];
        $row['PRIENTRADA']             = (!isset($row['PRIENTRADA'])             || empty($row['PRIENTRADA']))             ?  null : $row['PRIENTRADA'];
        $row['SEGENTRADA']             = (!isset($row['SEGENTRADA'])             || empty($row['SEGENTRADA']))             ?  null : $row['SEGENTRADA'];
        $row['PRISAIDA']               = (!isset($row['PRISAIDA'])               || empty($row['PRISAIDA']))               ?  null : $row['PRISAIDA'];
        $row['SEGSAIDA']               = (!isset($row['SEGSAIDA'])               || empty($row['SEGSAIDA']))               ?  null : $row['SEGSAIDA'];
        $row['IDATIVO']                = (!isset($row['IDATIVO'])                || empty($row['IDATIVO']))                ? 'S'  : $row['IDATIVO'];
 
    }
    
    public function deleteEscala($dataset) {
        try {
            $this->entityManager->beginTransaction();
            $escalah = $this->entityManager->getRepository(Repositories::GPE_ESCALATRABH)->findOneBy(array("nrescalatrabm" => $dataset['NRESCALATRABM'], "nrescalatrabh" => $dataset['NRESCALATRABH'],"nrorg" => $dataset['NRORG']));
            $this->entityManager->remove($escalah);
            $this->entityManager->flush();
            $escalahh = $this->entityManager->getRepository(Repositories::GPE_ESCALATRABH)->findOneBy(array("nrescalatrabm" => $dataset['NRESCALATRABM'],"nrorg" => $dataset['NRORG']));
            if(empty($escalahh)) {
                $escalam = $this->entityManager->getRepository(Repositories::GPE_ESCALATRABM)->findOneBy(array("nrescalatrabm" => $dataset['NRESCALATRABM'],"nrorg" => $dataset['NRORG']));
                $this->entityManager->remove($escalam);
                $this->entityManager->flush();
            }
            $this->entityManager->commit();
        } catch (\Exception $e) {            
            $this->entityManager->rollback();
            throw $e;
        }
    }
} 