<?php
namespace HCM\SST\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class AcaoRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }
    
    public function validaDelete($nracao, $nrorg) {
        $query = <<<SQL
                SELECT * 
                FROM LOGTRAMACAO
                WHERE NRACAO = :NRACAO
                AND NRORG = :NRORG
SQL;
        $parameters = 
        [
            "NRORG" => $nrorg,
            "NRACAO"  => $nracao
        ];
        
        $result = $this->connection->fetchAll($query,$parameters);
        
        if(!empty($result))
            return false;

$query = <<<SQL
                SELECT * 
                FROM LOGPREVACAO
                WHERE NRACAO = :NRACAO
                AND NRORG = :NRORG
SQL;
        $parameters = 
        [
            "NRORG" => $nrorg,
            "NRACAO"  => $nracao
        ];
        
        $result = $this->connection->fetchAll($query,$parameters);
        
        if(!empty($result))
            return false;

$query = <<<SQL
                SELECT * 
                FROM ETAPACAO
                WHERE NRACAO = :NRACAO
                AND NRORG = :NRORG
SQL;
        $parameters = 
        [
            "NRORG" => $nrorg,
            "NRACAO"  => $nracao
        ];
        
        $result = $this->connection->fetchAll($query,$parameters);
        
        if(!empty($result))
            return false;

$query = <<<SQL
                SELECT * 
                FROM OBSACAO
                WHERE NRACAO = :NRACAO
                AND NRORG = :NRORG
SQL;
        $parameters = 
        [
            "NRORG" => $nrorg,
            "NRACAO"  => $nracao
        ];
        
        $result = $this->connection->fetchAll($query,$parameters);
        
        if(!empty($result))
            return false;
        
        return true;        
    }
    
    public function getOperadorResponsavel($parameters, $conditions){
        $query = <<<SQL
            SELECT * 
              FROM (    
                SELECT OPERADOR.NMOPERADOR,
                       OPERADOR.CDOPERADOR,
                       OPERADOR.CDSETOR,
                       SETOR.NMSETOR
                  FROM OPERADOR
             LEFT JOIN SETOR ON SETOR.CDSETOR = OPERADOR.CDSETOR
                            AND SETOR.NRORG = OPERADOR.NRORG
                 WHERE OPERADOR.NRORG = :P_NRORG)
             WHERE 1 = 1
             $conditions
SQL;
        $params = array('P_NRORG' => $parameters['P_NRORG']);
        
        return $this->connection->fetchAll($query,$parameters);
        
    }
    
//     public function setFaseTramitaAcao($nrorg, $nracao, $cdfatramacao){
//         $query = <<<SQL
//             UPDATE ACAO 
//               SET CDFATRAMACAO = :P_CDFATRAMACAO
//              WHERE NRACAO = :P_NRACAO
//               AND NRORG = :P_NRORG
// SQL;
//         $params = array('P_CDFATRAMACAO' => $cdfatramacao,
//                         'P_NRACAO'       => $nracao,
//                         'P_NRORG'        => $nrorg);
                        
//         return $this->connection->fetchAssoc($query, $params);
              
//     }

} 

