<?php
/**
 * Created by JetBrains PhpStorm.
 * User: alessandrobartel
 * Date: 02/07/12
 * Time: 11:51
 * To change this template use File | Settings | File Templates.
 */

class RegistroFinanceiroHomolognet extends RegistroHomolognet{


    const SALARIOS = 'Salarios';
    const SALARIO = 'Salario';
    const RUBRICAS = 'Rubricas';
    const RUBRICA = 'Rubrica';
    const RUBRICAS_EXTERNAS = 'RubricasExternas';
    const RUBRICA_EXTERNA = 'RubricaExterna';
    const FINANCEIRO = 'Financeiro';

    const ANO_MES = 'DTAnoMes';
    const TIPO_FORMACAO = 'TPFormacao';
    const TIPO_SALARIO = 'TPSalario';
    const CODIGO_RUBRICA = 'CDTipoRubrica';
    const VALOR_RUBRICA = 'VLRubrica';
    const NUMERO_SEQ_PROUTO = 'NRSequencialProduto';
    const BASE_CALCULO = 'VLBaseCalculo';
    const QTD_PRODUTOS = 'NRQuantidadeProdutos';
    const PERCENTUAL_RUBRICA = 'PCPercentualRubrica';
    const NUMERO_HORAS = 'NRHoras';
    const CODIGO_RUBRICA_EXTERNA = 'CDRubricaExterna';
    const VERBA_RESCISORIA = 'VLVerbaRescisoria';
    const CODIGO_INCIDENTE_TRIBUTACAO = 'CDIncidenteTributacao';
    const CODIGO_INDICADOR_INTEGRACAO = 'CDIndicadorIntegracaoBaseCalculo';
    const QTD_DSR = 'NRQuantidadeDsr';
    const SALARIO_MES_ANTERIOR = 'VLSalarioLiquidoMesAnteriorRescisao';

    const FORMACAO_SALARIO_FIXO = 1;
    const FORMACAO_SALARIO_VARIAVEL = 2;
    const FORMACAO_SALARIO_FIXO_VARIAVEL = 3;

    const TIPO_SALARIO_HORA = 1;
    const TIPO_SALARIO_MENSAL = 2;
    const TIPO_SALARIO_DIARIO = 3;

    const MESES_FINANCEIROS = 85;
    const COD_RUBRICA_GARANTIA = '002';
    const COD_RUBRICA_COMISSAO = '007';

    private $_codSequencialProduto = 1;

    private $_salario;
    private $_rubrica;
    private $_rubricaExterna;


    public function getCodSequencialProduto(){
        return $this->_codSequencialProduto;
    }


    public function incrementaCodSequencialProduto(){
        $this->_codSequencialProduto++;
    }


    public function setRubrica($rubrica = null){
        $this->_rubrica = $rubrica;
    }


    public function setRubricaExterna($rubricaExterna = null){
        $this->_rubricaExterna = $rubricaExterna;
    }


    public function setSalario($salario){
        $this->_salario = $salario;
    }


    /* Verificar o modo que foi feito em Registro13SalarioHomolognet */

    public function concatenaSalario(){
        $this->_salario .= $this->getLinhaRegistro();
    }

    public function concatenaRubrica(){
        // em outros metodos esta passando parametro pra ca, que nada mais eh o getLinhaRegistro
        $this->_rubrica .= $this->getLinhaRegistro();
    }

    public function concatenaRubricaExterna(){
        $this->_rubricaExterna .= $this->getLinhaRegistro();
    }

    
    public function geraRegistroSalario($salarios){

        foreach ($salarios as $key => $salario) {

            // Atribuicao da tag Salarios
            $tag = self::SALARIO;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

            // Campo 61 - tamanho 06 - Mês/Ano do salário.
            $this->_atribuiAnoMes($key);

            // Campo 62 - tamanho 01 - Formacao do Salario.
            $this->_atribuiTipoFormacao($salario['tipoFormacao']);

            // Campo 63 - tamanho 01 - Tipo salario fixo.
            $this->_atribuiTipoSalario($salario['tipoSalario']);

            // Atribui ao salário, a tag das rubricas internas
    //        if (empty($this->_rubrica) === false) {

                $tag = self::RUBRICAS;
                $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

                // Pegar todas as rubricas para a formacao do salario
    //            $this->atribuiDadoXML(null, null, $this->_rubrica, strlen($this->_rubrica), 0, 0);
                $this->geraRegistroRubrica($salario['rubricas']);

                $tag = parent::CARACTER_FINALIZADOR;
                $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);
    //        }

            // Atribui ao salário, a tag das rubricas externas
            if (empty($this->_rubricaExterna) === false) {

                $tag = self::RUBRICAS_EXTERNAS;
                $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

                // Pegar todas as rubricas externas para a formacao do salario
//                $this->atribuiDadoXML(null, null, $this->_rubricaExterna, strlen($this->_rubricaExterna), 0, 0);
                $this->geraRegistroRubricaExterna($salario['rubricasExternas']);

                $tag = parent::CARACTER_FINALIZADOR;
                $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);
            }

            $tag = parent::CARACTER_FINALIZADOR;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

        }

    }

    public function geraRegistroRubrica($rubricas){

        foreach ($rubricas as $rubrica) {

            // Atribuicao tag Rubrica
            $tag = self::RUBRICA;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

            // Campo 64 - tamanho 03 - Codigo da rubrica salarial.
            $this->_atribuiCodigoRubrica($rubrica['codigo']);

            // Campo 65 - tamanho 14 - Valor.
            $this->_atribuiValorRubrica($rubrica['valor']);

            // Campo 66 - tamanho 20 - Codigo sequencial do produto.
            $this->_atribuiSequencialProduto($rubrica['seqCodigo']);

            // Campo 67 - tamanho 14 - Base de calculo
            $this->_atribuiBaseCalculo($rubrica['baseCalculo']);

            // Campo 68 - tamanho 09 - Quantidade de produtos produzidos.
            $this->_atribuiQuantidadeProduto($rubrica['quantidade']);

            // Campo 69 - tamanho 05 - Percentual aplicado.
            $this->_atribuiPercentualRubrica($rubrica['percentual']);

            // Campo 70 - tamanho 05 - Quantidade Horas.
            $this->_atribuiNumeroHoras($rubrica['horas']);

            $tag = parent::CARACTER_FINALIZADOR;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

            // Rubrica Garantia deve ser gerada quando houver Rubrica Comissão
            if ($rubrica['codigo'] === self::COD_RUBRICA_COMISSAO) {
                $this->geraRegistroRubricaGarantia();
            }
        }
    }

    public function geraRegistroRubricaExterna($rubricasExternas){

        foreach ($rubricasExternas as $rubricaExterna) {

            $tag = self::RUBRICA_EXTERNA;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

            // Campo 72 - tamanho 03 - Codigo da verba rescisoria (outras)
            $this->_atribuiCodigoRubricaExterna($rubricaExterna['codigo']);

            // Campo 73 - tamanho 14 - Valor das verbas rescisorias (outras).
            $this->_atribuiVerbaRescisoria($rubricaExterna['valor']);

            // Campo 74 - tamanho 03 - Indicador de incidência de Tributação - Outras verbas rescisórias.
            $this->_atribuiIncidenteTributacao($rubricaExterna['incidencia']);

            // Campo 75 - tamanho 03 - Indicador de integração de Base de Cálculo (outras).
            $this->_atribuiIndicadorIntegracaoBaseCalculo($rubricaExterna['integracao']);

            $tag = parent::CARACTER_FINALIZADOR;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

        }

    }

    public function geraRegistroFinanceiro($financeiro, $salarios){
        $this->_geraRegistro($financeiro, $salarios);
    }

    // Rubrica Garantia deve ser gerada quando houver Rubrica Comissão
    private function geraRegistroRubricaGarantia() {

        // Atribuicao tag Rubrica
        $tag = self::RUBRICA;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

        // Campo 64 - tamanho 03 - Codigo da rubrica salarial.
        $this->_atribuiCodigoRubrica(self::COD_RUBRICA_GARANTIA);

        // Campo 65 - tamanho 14 - Valor.
        $this->_atribuiValorRubrica('0.00');

        $tag = parent::CARACTER_FINALIZADOR;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

    }

    private function _geraRegistro($financeiro, $salarios){

        // Atribuicao da tag Salarios
        $tag = self::SALARIOS;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

        // Pegar a tag de salarios ja montada.
//        $this->atribuiDadoXML(null, null, $this->_salario, strlen($this->_salario), 0, 0);
        $this->geraRegistroSalario($salarios);

        $tag = parent::CARACTER_FINALIZADOR;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

        // Campo 76 - tamanho 01 - Quantidade de DSR que o empregado faz jus no mês do afastamento com exceção da última semana.
        $this->_atribuiQuantidadeDSR($financeiro->dsr);

        // Campo 71 - tamanho 14 - Salário líquido do empregado referente ao mês anterior à rescisão
        $this->_atribuiSalarioMesAnterior($financeiro->liquido);

    }


    private function _atribuiAnoMes($anoMes){
     /* . Informe de acordo com o formato: aaaamm.
      * · Os campos 61 a 75 são correspondentes de forma combinada a cada uma das ocorrências nos últimos 85 meses incluindo o mês da rescisão.
      * · Deverão ser informados no mínimo os últimos 24 meses (contratos com mais de dois anos de vigência), no caso de todas as férias terem sido integralmente quitadas e todos
      *   os 13º Salários integralmente pagos. Caso contrário, deverá ser informado o maior dos períodos: a partir do início do primeiro período aquisitivo de férias mais antigo
      *   ainda não quitado ou do primeiro mês do ano-calendário mais antigo em que não foi pago ou foi pago parcialmente o décimo-terceiro salário.
      */
        // $dado = '1';
        if (empty($anoMes) === false) {

            $data = new TkDateTime($anoMes);
            $ano = $data->toString(TkDateTime::YEAR);
            $mes = $data->toString(TkDateTime::MONTH);
            unset($data);

            $tag = self::ANO_MES.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $ano.$mes, 6);
        }
        
    }


    private function _atribuiTipoFormacao($tipoFormacao){
    /* · Este campo terá sua ocorrência condicionada e correspondente ao campo 61
     * · Informe de acordo com o seguinte domínio: 1. Fixo / 2. Variável / 3. Fixo + Variável
     * · Opções mutuamente excludentes.
     */
        $dado = $tipoFormacao;
        if (empty($dado) === false) {
            $tag = self::TIPO_FORMACAO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 1);
        }
    }


    private function _atribuiTipoSalario($tipoSalario){
    // Informe de acordo com domínio: 1. Hora / 2. Mensal / 3. Diário
        $dado = $tipoSalario;
        if (empty($dado) === false) {
            $tag = self::TIPO_SALARIO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 1);
        }

    }


    private function _atribuiCodigoRubrica($codigo){
    /* · Este campo está vinculado ao campo 61.
     * · Os campos 64 a 70 são correspondentes de forma combinada a cada uma das ocorrências nos últimos 85 meses incluindo o mês da rescisão.
     * · Informe de acordo com a tabela de Rubricas (verificar layout homolognet no site do Ministerio do Trabalho)
     */
        $dado = $codigo;
        if (empty($dado) === false) {
            $tag = self::CODIGO_RUBRICA.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 3);
        }
    }


    private function _atribuiValorRubrica($valor){
    /* · A obrigatoriedade deste campo está vinculada à rubrica salarial preenchida no campo 64, para aquelas cuja coluna
     *   “VALOR” na tabela de rubricas esteja assinalada com “X”.
     * · A rubrica “Salário fixo” deverá ser informada de acordo com o campo 63 (Tipo de Salário Fixo), ou seja, saláriohora, salário-dia ou salário-mês.
     * · Informar com duas casas decimais.
     */
        $dado = $valor;
        if (empty($dado) === false) {
            $tag = self::VALOR_RUBRICA.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
        }
    }


    private function _atribuiSequencialProduto($sequencial){
    /* · A obrigatoriedade deste campo está vinculada ao tipo de salário variável preenchido no campo 64, desde que referente a produção.
     * · Os campos 66 a 68 são correspondentes de forma combinada a cada uma das ocorrências de produtos informados.
     * · Para cada tipo de produto, deverá ser informado o seu código seqüencial.
     * · Para cada um dos códigos de produtos informados no arquivo deverá ser estabelecida a correlação com suas respectivas descrições
     *   nos campos 93 a 95, de forma combinada.
     */
        $dado = $sequencial;
        if (empty($dado) === false) {
            $tag = self::NUMERO_SEQ_PROUTO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 20);
        }
    }


    private function _atribuiBaseCalculo($baseCalculo){
    /* · A obrigatoriedade deste campo está vinculada ao tipo de salário variável preenchido no campo 64.
     * · Para a rubrica “Produção”, este campo terá sua ocorrência condicionada e correspondente ao campo 66, onde, para cada
     *   produto informado, deverá ser preenchido seu valor monetário correspondente. Neste caso, o campo 68 deverá ser obrigatório
     *   para cada uma das ocorrências registradas.
     * · Para as rubricas preenchidas no campo 64 correspondentes a: “insalubridade”, “periculosidade”, “adicional tempo de serviço”, e
     *   “adicional por transferência de localidade de trabalho” deverá ser informado o valor da base de cálculo que será utilizada para
     *   determinar seus respectivos valores agregados.
     * · Para a rubrica “Adicional por Tempo de Serviço”, a base de cálculo informada deverá estar acrescida da “Gratificação Semestral”
     *   (caso recebida pelo empregado), para atendimento do disposto no Enunciado n.º 253 do TST.
     * · Informar com duas casas decimais.
     */
        $dado = (string)$baseCalculo;
        if (empty($dado) === false) {
            $tag = self::BASE_CALCULO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
        }
    }


    private function _atribuiQuantidadeProduto($quantidadeProduto){
    /* · Formatação inclui duas casas decimais.
     * · A obrigatoriedade deste campo está vinculada ao tipo de salário variável preenchido no campo 64, desde que referente a produção.
     * · Este campo terá sua ocorrência condicionada e correspondente ao campo 66.
     * · Para cada produto informado, deverá ser preenchida esta quantidade.
     */
        $dado = $quantidadeProduto;
        if (empty($dado) === false) {
            $tag = self::QTD_PRODUTOS.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 9);
        }
    }


    private function _atribuiPercentualRubrica($percentual){
    /* · A obrigatoriedade deste campo está vinculada ao tipo de salário fixo ou variável preenchido no campo 64, para os quais se aplique
     *   percentuais para obtenção do valor associado.
     * · Caso exista mais de um percentual de horas-extras e respectiva quantidade de horas a serem informados, devese repetir para cada
     *   mês o código da rubrica hora-extra vinculando cada percentual às respectivas quantidades de horas-extras realizadas.
     * · Informar com duas casas decimais.
     */
        $dado = $percentual;
        if (empty($dado) === false) {
            $tag = self::PERCENTUAL_RUBRICA.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 5, true);
        }
    }

    // Campo 70
    private function _atribuiNumeroHoras($horas){
    /* · A obrigatoriedade deste campo está vinculada ao tipo de salário variável preenchido no campo 64.
     * · Se a Quantidade a ser informada for em “horas”, converter de unidade sexagesimal para decimal e informar com duas casas decimais.
     * · A rubrica “Horas Trabalhadas no Mês” deverá ser informada apenas quando o salário for remunerado em horas (conforme campo 63, domínio “1 - Hora”).
     * · A rubrica “Número de Dias Trabalhados no Mês” deverá ser informada apenas quando o salário for remunerado em dias
     *   (conforme campo 63, domínio “3 - Diário”).
     * . Informar com duas casas decimais.
     */
        $dado = $horas;
        if (empty($dado) === false) {
            $tag = self::NUMERO_HORAS.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 5, true);
        }
    }


    private function _atribuiCodigoRubricaExterna($codigo){
    /* · Os campos 72 a 75 são correspondentes de forma combinada a cada uma das ocorrências de verbas rescisórias informadas.
     * · A codificação das verbas deverá iniciar em 100.
     * · Para cada um dos códigos de verbas informadas no arquivo deverá ser estabelecida a correlação com suas respectivas
     *   descrições nos campos 93 a 95, de forma combinada.
     */
        $dado = $codigo;
        if (empty($dado) === false) {
            $tag = self::CODIGO_RUBRICA_EXTERNA.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 3);
        }
    }


    private function _atribuiVerbaRescisoria($valor){
    /* · Este campo terá sua ocorrência condicionada e correspondente ao campo 72.
     * · Campo obrigatório, caso campo 72 seja informado.
     * · Informar com duas casas decimais.
     */
        $dado = $valor;
        if (empty($dado) === false) {
            $tag = self::VERBA_RESCISORIA.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
        }
    }


    private function _atribuiIncidenteTributacao($incidencia){
    /* · Este campo terá sua ocorrência condicionada e correspondente ao campo 72.
     * · Informar a incidência de tributação para estas verbas rescisórias. Para indicar a incidência, deverá ser informado
     *   valor Zero caso não incida e valor Um caso incida, onde:
     *   1) A primeira posição será referente ao FGTS;
     *   2) A segunda posição será referente ao INSS;
     *   3) A terceira posição será referente ao IRRF.
     *   Ex.: 001, onde “0” na primeira posição informa a não incidência do FGTS, “0” na segunda posição informa a
     *   não incidência do INSS e “1” na terceira posição informa a incidência do IRRF.
     * · Campo obrigatório para o caso do campo 72 ter sido informado.
     */
        $dado = $incidencia;
        if (empty($dado) === false) {
            $tag = self::CODIGO_INCIDENTE_TRIBUTACAO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 3);
        }
    }


    private function _atribuiIndicadorIntegracaoBaseCalculo($integracao){
    /* · Este campo terá sua ocorrência condicionada e correspondente ao campo 72.
     * · Informar quais bases de cálculo que a verba rescisória informada integra em sua apuração (se ela integra cálculos
     *   de décimo terceiro, férias e aviso prévio). Deverá ser informado valor Zero caso não incida e valor Um caso incida, onde:
     *   1) A primeira posição será referente a Férias;
     *   2) A segunda posição será referente ao 13º salário;
     *   3) A terceira posição será referente ao Aviso Prévio.
     *   Ex.: 001, onde “0” na primeira posição informa que a verba rescisória não integrará o cálculo das Férias, “0”
     *   na segunda posição informa que a verba rescisória não integrará o cálculo do 13º salário e “1” na terceira
     *   posição informa que a verba rescisória integrará o cálculo do Aviso Prévio.
     */
        $dado = $integracao;
        if (empty($dado) === false) {
            $tag = self::CODIGO_INDICADOR_INTEGRACAO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 3);
        }
    }


    private function _atribuiQuantidadeDSR($dsr){
        $dado = $dsr;
        if (empty($dado) === false) {
            $tag = self::QTD_DSR.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 1);
        }
    }


    private function _atribuiSalarioMesAnterior($liquido){
    /* · Informar com duas casas decimais.
     * · Só informar para pagamento na rescisão caso o salário do mês anterior ainda não tenha sido pago e a data de
     *   quitação da rescisão do contrato de trabalho venha a ocorrer até o quinto dia útil do mês seguinte ao de
     *   pagamento do salário não quitado.
     */
        $dado = $liquido;
        if (empty($dado) === true) {
            $dado = '0.00';
        }
        $tag = self::SALARIO_MES_ANTERIOR.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);

    }




}

